function setCookie(cname, cvalue) {
    document.cookie = cname + "=" + cvalue;
}

function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
}

function deleteCookie(cname) {
    document.cookie = cname + '=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';
}

OrderCloud.Auth = {
    impersonating: false,
    appname: appname ? appname : 'OrderCloud',
    GetToken: function() {
        return this.impersonating ? getCookie(this.appname + 'impersonating.token').Token : getCookie(this.appname + '.token');
    },
    SetToken: function(token) {
        setCookie(this.appname + '.token', token);
    },
    RemoveToken: function() {
        deleteCookie(this.appname + '.token');
    },
    IsAuthenticated: function() {
        var deferred = Q.defer();

        if (getCookie(this.appname + '.token')) {
            deferred.resolve(getCookie(this.appname + '.token'));
        } else {
            deferred.reject();
        }
        return deferred.promise;
    },
    SetImpersonationToken: function(userID, token) {
        var tokenObject = {
            UserID: userID,
            Token: token
        };
        setCookie(this.appname + 'impersonating.token', tokenObject);
    },
    ClearImpersonationToken: function() {
        deleteCookie(this.appname + 'impersonating.token');
    },
    IsImpersonating: function() {
        return this.impersonating;
    },
    SetImpersonating: function(bool) {
        this.impersonating = bool;
    },
    GetImpersonating: function() {
        return getCookie(this.appname + 'impersonating.token');
    },
    Impersonate: function(token) {
        if (token) this.SetImpersonationToken(token);
        this.impersonating = true;
    }
};